/* collisiontriangle.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _COLLISIONTRIANGLE_H
#define _COLLISIONTRIANGLE_H

#include "vector3d.h"
#include "collisionface.h" /* interface */

/* 르ꥺ */
#define COLLISION_TRIANGLE_ALGO_DEFAULT       0
#define COLLISION_TRIANGLE_ALGO_VECTOR_SMOOTH 1

/* 󥿡եȼäѷѾȽ깽¤ */
typedef struct tagCollisionTriangle
{
  CollisionFace common;

  /* edge */
  Vector3D vertex[3];
  
  /* face */
  Vector3D normal;
  double d;

} CollisionTriangle;

/*  */
CollisionTriangle *createCollisionTriangle( const int algo );

/* ˴ */
void destroyCollisionTriangle( CollisionTriangle * );

/* ѷξ򥻥å */
void setTriangleCollisionTriangle( CollisionTriangle *, 
                                   Vector3D *v0, Vector3D *v1, Vector3D *v2 );

/* ץؿ */
int detectWithVector3DCollisionTriangle( CollisionTriangle *target, Vector3D *from, Vector3D *to, 
                                         Vector3D *modified_to );
#endif
