/* keyframe.c	-- Yasuhiro Yamazaki Sat Jan  5 2002
 */
#include <stdio.h>
#include <stdlib.h>

#include "keyvalue.h"
#include "keyframe.h"

/*  */
KeyFrame *
createKeyFrame( const double timing )
{
  KeyFrame *ret = (KeyFrame *)malloc( sizeof( KeyFrame ) );
  ret->ref = 1;
  ret->timing = timing;
  ret->prev = NULL;
  ret->next = NULL;
  ret->list = NULL;
  return ret;
}

/* ˴ */
void 
destroyKeyFrame( KeyFrame *k )
{
  if( k!=NULL ){
    if( --k->ref<=0 ){
      if( k->list!=NULL ){
        destroyKeyValues( k->list );
      }
      free( k );
    }
  }
}

void
destroyKeyFrames( KeyFrame *begin )
{
  if( begin!=NULL ){
    KeyFrame *k = begin, *reserve = begin;
    do{
      k = begin->next;
      destroyKeyFrame( reserve );
      reserve = k;
    } while( k!=NULL );
  }
}

/* ³ */
void 
linkKeyFrame( KeyFrame *target, KeyFrame *branch )
{
  if( target!=NULL && branch!=NULL ){
    KeyFrame *check = target, *reserve;

    /* åȤΥ󥯤饹Ȥ٤õ */
    while( check!=NULL ){
      reserve = check;
      if( check->timing<branch->timing ){
	check = check->next;
	if( check==NULL ){
	  branch->prev = reserve;
	  reserve->next = branch;
          branch->ref++;
	  break;
	} else if( !(check->timing<branch->timing) ){
	  reserve->next = branch;
	  branch->prev = reserve;
	  branch->next = check;
	  check->prev = branch;
          branch->ref++;
	  break;
	}
      } else if( check->timing>branch->timing ){
	check = check->prev;
	if( check==NULL ){
	  branch->next = reserve;
	  reserve->prev = branch;
          branch->ref++;
	  break;
	} else if( !(check->timing>branch->timing) ){
	  reserve->prev = branch;
	  branch->next = reserve;
	  branch->prev = check;
	  check->next = branch;
          branch->ref++;
	  break;
	}
      } else {
	/* ˰פϽʣǤʤΤǥ顼 (쥢) */
        KeyValueAbstract *tmp = check->list;
        check->list = branch->list;
        branch->list = tmp;
        break;
      }
    }
  }
}

/* ͤΥꥹȤɲ */
void 
addKeyValueToKeyFrame( KeyFrame *frame, KeyValueAbstract *value )
{
  if( frame!=NULL && value!=NULL ){
    KeyValueAbstract *reserve = frame->list;
    frame->list = value;
    value->common.ref++;
    linkKeyValue( value, reserve ); 
  }
}

/* enum */
KeyFrame *
prevKeyFrame( KeyFrame *k )
{
  KeyFrame *ret = NULL;
  if( k!=NULL && k->prev!=NULL ){
    ret = k->prev;
  }
  return ret;
}

KeyFrame *
nextKeyFrame( KeyFrame *k )
{
  KeyFrame *ret = NULL;
  if( k!=NULL && k->next!=NULL ){
    ret = k->next;
  }
  return ret;
}

/* timing */
void 
setTimingKeyFrame( KeyFrame *k, const double timing )
{
  if( k!=NULL ){
    k->timing = timing;
  }
}

double 
getTimingKeyFrame( KeyFrame *k )
{
  double ret = 0.0;
  if( k!=NULL ){
    ret = k->timing;
  }
  return ret;
}

/* key abstract */
void 
setKeyValueToKeyFrame( KeyFrame *target, KeyValueAbstract *value )
{
  if( target!=NULL ){
    if( target->list!=NULL ){
      destroyKeyValue( target->list );
    }
    target->list = value;
    value->common.ref++;
  }
}

KeyValueAbstract *
getKeyValueFromKeyFrame( KeyFrame *target )
{
  KeyValueAbstract *ret = NULL;
  if( target!=NULL && target->list ){
    ret = target->list;
    ret->common.ref++;
  }
  return ret;
}

