/* keyframe.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _KEYFRAME_H
#define _KEYFRAME_H

#include "keyvalue.h"

/* ¤ */
typedef struct tagKeyFrame
{
  int ref;

  double timing; /*  */
  struct tagKeyFrame *prev, *next; /* ե졼Υ */
  
  KeyValueAbstract *list; /* ͤΥꥹ */

} KeyFrame;

/*  */
KeyFrame *createKeyFrame( const double timing );

/* ˴ */
void destroyKeyFrame( KeyFrame * );
void destroyKeyFrames( KeyFrame *begin );

/* ³ */
void linkKeyFrame( KeyFrame *target, KeyFrame *branch );

/* ͤΥꥹȤɲ */
void addKeyValueToKeyFrame( KeyFrame *frame, KeyValueAbstract *value );

/* enum */
KeyFrame *prevKeyFrame( KeyFrame * );
KeyFrame *nextKeyFrame( KeyFrame * );

/* timing */
void setTimingKeyFrame( KeyFrame *, const double timing );
double getTimingKeyFrame( KeyFrame * );

/* key abstract */
void setKeyValueToKeyFrame( KeyFrame *target, KeyValueAbstract *value );
KeyValueAbstract *getKeyValueFromKeyFrame( KeyFrame *target );

#endif
