/* keyframebind.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */
#ifndef _KEYFRAMEBIND_H
#define _KEYFRAMEBIND_H

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <GL/gl.h>

#include "modelbone.h"
#include "keyframelist.h"

typedef struct tagKeyFrameBind
{
  int ref;

  GLuint id;
  ModelBone *bone;

  /* assigned parameters */
  KeyFrameList *rotate1;
  KeyFrameList *rotate2;

  /* link list */
  struct tagKeyFrameBind *next;

} KeyFrameBind;

/* Method */

KeyFrameBind *createKeyFrameBind( const GLuint id );

void destroyKeyFrameBind( KeyFrameBind * );
void destroyKeyFrameBinds( KeyFrameBind * );

void setModelBoneKeyFrameBind( KeyFrameBind *, ModelBone * );
ModelBone *getModelBoneKeyFrameBind( KeyFrameBind * );

/* link */
void linkKeyFrameBind( KeyFrameBind *target, KeyFrameBind *branch );
KeyFrameBind *nextKeyFrameBind( KeyFrameBind * );

/* add new animation */
void addKeyFrameKeyFrameBind( KeyFrameBind *target, KeyFrame *begin, const double current_time );

/* execution utility */
void applyKeyFrameBind( KeyFrameBind *, const double current_time );
void expireOldKeyFrameKeyFrameBind( KeyFrameBind *, const double current_time );

#endif
