/* keyframelist.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */
#ifndef _KEYFRAMELIST_H
#define _KEYFRAMELIST_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

#include "keyframe.h"

typedef struct tagKeyFrameList
{
  int ref;
  unsigned int no;

  KeyFrame *key_frame;
  struct tagKeyFrameList *next;
} KeyFrameList;

/* Method */

KeyFrameList *createKeyFrameList( void );

void destroyKeyFrameList( KeyFrameList * );
void destroyKeyFrameLists( KeyFrameList *begin );

void linkKeyFrameList( KeyFrameList *target, KeyFrameList *branch );

KeyFrame *getKeyFrameFromKeyFrameList( KeyFrameList * );
void setKeyFrameToKeyFrameList( KeyFrameList *, KeyFrame * );

KeyFrame *searchKeyFrameFromKeyFrameLists( KeyFrameList *begin, const unsigned int no );

/* enum */
KeyFrameList *nextKeyFrameList( KeyFrameList * );

/* delete item (return a new list pointer) */
KeyFrameList *deleteKeyFrameList( KeyFrameList *begin, const GLuint id );

#endif
