/* keyvalue.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _KEYVALUE_H
#define _KEYVALUE_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

#include "vector3d.h"

#define KEY_VALUE_TYPE_NONE    0
#define KEY_VALUE_TYPE_ROTATE1 1
#define KEY_VALUE_TYPE_ROTATE2 2

/* إå */
typedef struct tagKeyValueInterface
{
  int ref;

  int type; /* ¤Τμ */
  void *next; /*  */
  GLuint id; /* ɤΥ֥Ȥ˴Ϣͤ */

  /* ֤Τδؿ򤳤Ͽ 
   * src1  src2 ַ̤򼫤ι¤Τ˳Ǽ
   */
  void (*linearInterpolation)(void *dst, void *src1, void *src2, double rate);

  /* add src to dst */
  void (*add)(void *dst, void *src);

} KeyValueInterface;


/* None */
typedef struct tagKeyValueNone
{
  KeyValueInterface common;
} KeyValueNone;

/* Rotate1/2 */
typedef struct tagKeyValueRotate1
{
  KeyValueInterface common;
  double degree;
} KeyValueRotate1;

typedef struct tagKeyValueRotate2
{
  KeyValueInterface common;
  double degree;
} KeyValueRotate2;

/* Abstract */
typedef union
{
  KeyValueInterface common;
  KeyValueNone none;
  KeyValueRotate1 rotate1;
  KeyValueRotate2 rotate2;
} KeyValueAbstract;

/* Method */

/*  */
KeyValueAbstract *createKeyValue( const int type, const int id );

/* ˴ */
void destroyKeyValue( KeyValueAbstract * );
void destroyKeyValues( KeyValueAbstract *begin );

/* ʣ */
KeyValueAbstract *croneKeyValue( KeyValueAbstract * );
int copyKeyValue( KeyValueAbstract *dst, KeyValueAbstract *src );

/* ³ */
void linkKeyValue( KeyValueAbstract *target, KeyValueAbstract *branch );

/* enum */
KeyValueAbstract *nextKeyValue( KeyValueAbstract * );

#endif
