/* modelbone.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _MODELBONE_H
#define _MODELBONE_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

#include "vector3d.h"
#include "trimodel.h"

/*  */
typedef struct tagModelBone
{
  /* reference counter */
  int ref;

  /* identification number */
  GLuint name;

  /* object information */
  Vector3D scale;
  Vector3D translate;
  Vector3D center;
  Vector3D axis1, axis2;
  double rotate1, rotate2;
  TriModel *model;

  /* link information */
  struct tagModelBone *brother, *child;

} ModelBone;

/* Method */

/*  */
ModelBone *createModelBone( const char *model_filename );

/* ˴ */
void destroyModelBone( ModelBone * );
void destroyLinkedModelBone( ModelBone *root );

/* ƴ󥯤ƿƻҴطۤ */
void linkAsBrotherModelBone( ModelBone *root, ModelBone *brother );
void linkAsChildModelBone( ModelBone *parent, ModelBone *child );

/* ɽ */
void putModelBone( const ModelBone * );
void putLinkedModelBone( const ModelBone *root );

/* Υѥ᡼ѹ */
void setIDNumberModelBone( ModelBone *, const GLuint id );
void setScaleModelBone( ModelBone *, const Vector3D scale );
void setTranslateModelBone( ModelBone *, const Vector3D translate );
void setCenterModelBone( ModelBone *, const Vector3D center );
void setAxis1ModelBone( ModelBone *, const Vector3D axis1 );
void setAxis2ModelBone( ModelBone *, const Vector3D axis2 );
void setRotate1ModelBone( ModelBone *, const double rotate1 );
void setRotate2ModelBone( ModelBone *, const double rotate2 );

/* ID 򥵡 */
ModelBone *searchLinkedModelBone( ModelBone *root, const GLuint id );

#endif
