/* vector3d.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _VECTOR3D_H
#define _VECTOR3D_H

typedef struct tagVector3D
{
  int ref;

  float x, y, z;
} Vector3D;

/*  */
Vector3D *createVector3D( void );
Vector3D *createVector3Df( const float x, const float y, const float z );
Vector3D *createVector3Dv( const float *v );

/*  */
Vector3D *croneVector3D( const Vector3D *v );

/* ˴ */
void destroyVector3D( Vector3D *v );

/* ͤ */
void setVector3DCoordinatef( Vector3D *v, const float x, const float y, const float z );
void setVector3DCoordinatev( Vector3D *v, const float *f );
void copyVector3D( Vector3D *v, const Vector3D *from );

/* ׻ */
void addVector3D( Vector3D *v, Vector3D *a, Vector3D *b ); /* v = a + b; */
void subVector3D( Vector3D *v, Vector3D *a, Vector3D *b ); /* v = a - b; */
void multiplyVector3D( Vector3D *v, const float a ); /* v *= a; */
void divideVector3D( Vector3D *v, const float a );   /* v /= a; */
float normalizeVector3D( Vector3D *v );              /* v /= normal */

float dotProductVector3D( Vector3D *a, Vector3D *b );
void crossProductVector3D( Vector3D *v, Vector3D *a, Vector3D *b );

float getNormal( Vector3D *v );

#endif
